-- PFT trace decoder
-- 2nd version
-- Decode trace generated by PTM and recovered in the PL through TPIU (Trace Port Interface Unit)

library ieee;
use ieee.std_logic_1164.all;
use IEEE.numeric_std.all;

entity test_bench is
end entity;

architecture test1 of test_bench is
signal data_in : std_logic_vector(7 downto 0) := (others => '0');
signal clk : std_logic := '0';
signal reset : std_logic;
signal enable, fifo_overflow : std_logic;
signal pc  : std_logic_vector(31 downto 0) := (others => '0');
signal w_en, rd_en : std_logic;
signal waypoint_address : std_logic_vector(31 downto 0);
signal waypoint_address_en : std_logic;
signal count : std_logic_vector(9 downto 0);

-- component declaration
component decodeur_traces
generic (ctxtid_bits : std_logic_vector(1 downto 0) := "00");
port(
clk, reset, enable : in std_logic;
trace_data : in std_logic_vector(7 downto 0);
pc : out std_logic_vector(31 downto 0);
w_en, fifo_overflow : out std_logic;
waypoint_address : out std_logic_vector(31 downto 0);
waypoint_address_en : out std_logic
);
end component;

begin
u1: decodeur_traces
    generic map(ctxtid_bits => "11") 
    port map (
	clk,reset, enable, data_in, pc, w_en, fifo_overflow, waypoint_address, waypoint_address_en
	);

clock_tic: process
begin
--wait for 1 ns;
loop
clk <= '1'; wait for 2 ns;
clk <= '0'; wait for 2 ns;
end loop;
end process;
--clk <= not clk after 5 ns;

input_changes : process
begin
count <= "0000000000" after 0 ns,
"0000000001" after 40 ns,
"0010000000" after 100 ns;


reset <= '0' after 0 ns,
'0' after 10 ns,
'0' after 70 ns,
'0' after 80 ns,
'0' after 90 ns;
--enable <= '1' after 0 ns;
-- testing all packets especially i-sync ones (instruction_address field in particular)
--reset <= '0' after 0 ns,
--'0' after 10 ns;
--read_en <= '1' after 0 ns,
--'1' after 20 ns,
--'0' after 400 ns,
--'1' after 420 ns;
--is_exception_enabled     <= '0' after 0 ns;
--isCycleAccurate_enabled  <= '1' after 0 ns;
--isBranchBroadcast_enabled<= '0' after 0 ns;
--data_in <= X"00" after 0 ns,
--X"80" after 20 ns,
--X"08" after 30 ns,
--X"00" after 40 ns,
--X"10" after 50 ns,
--X"11" after 60 ns,
--X"00" after 70 ns,
--X"01" after 80 ns,
--X"72" after 90 ns,
--X"0C" after 100 ns,
--X"6E" after 150 ns,
--X"3C" after 200 ns,
--X"80" after 210 ns,
--X"00" after 220 ns,
--X"00" after 260 ns,
--X"01" after 280 ns,
--X"00" after 290 ns,
--X"08" after 350 ns;

-- data for_trace.txt (E:\Downloads\final_trace\for_loop\100_iterations\for_trace.txt)
-- First 5 lines of the file mentionned above are present here
--enable <= '1' after 0 ns,
--'1' after 10 ns,
--'1' after 80 ns,
--'1' after 90 ns,
--'1' after 270 ns,
--'1' after 280 ns,
--'0' after 1660 ns,
--'1' after 1680 ns,
--'0' after 1740 ns,
--'1' after 1780 ns,
--'0' after 1820 ns,
--'1' after 1830 ns;
--data_in <= X"00" after 0 ns,
--X"08" after 10 ns,
--X"34" after 20 ns,
--X"15" after 30 ns,
--X"10" after 40 ns,
--X"00" after 50 ns,
--X"21" after 60 ns,
--X"c4" after 70 ns,
--X"b0" after 80 ns,
--X"bb" after 90 ns,
--X"b0" after 100 ns,
--X"02" after 110 ns,
--X"63" after 120 ns,
--X"3C" after 130 ns,
--X"29" after 140 ns,
--X"64" after 150 ns,
--X"05" after 160 ns,
--X"DD" after 170 ns,
--X"1D" after 180 ns,
--X"24" after 190 ns,
--X"AB" after 200 ns,
--X"15" after 210 ns,
--X"4C" after 220 ns,
--X"07" after 230 ns,
--X"C6" after 240 ns,
--X"02" after 250 ns,
--X"CF" after 260 ns,
--X"1C" after 270 ns,
--X"08" after 280 ns,
--X"08" after 290 ns,
--X"A4" after 300 ns,
--X"15" after 310 ns,
--X"10" after 320 ns,
--X"00" after 330 ns,
--X"21" after 340 ns,
--X"F0" after 350 ns,
--X"C8" after 360 ns,
--X"8E" after 370 ns,
--X"06" after 380 ns,
--X"5D" after 390 ns,
--X"28" after 400 ns,
--X"29" after 410 ns,
--X"4C" after 420 ns,
--X"01" after 430 ns,
--X"DD" after 440 ns,
--X"1D" after 450 ns,
--X"24" after 460 ns,
--X"AB" after 470 ns,
--X"15" after 480 ns,
--X"68" after 490 ns,
--X"01" after 500 ns,
--X"E2" after 510 ns,
--X"01" after 520 ns,
--X"CF" after 530 ns,
--X"1C" after 540 ns,
--X"51" after 550 ns,
--X"08" after 560 ns,
--X"00" after 570 ns,
--X"00" after 580 ns,
--X"00" after 590 ns,
--X"00" after 600 ns,
--X"00" after 610 ns,
--X"80" after 620 ns,
--X"08" after 630 ns,
--X"9C" after 640 ns,
--X"1C" after 650 ns,
--X"10" after 660 ns,
--X"00" after 670 ns,
--X"01" after 680 ns,
--X"08" after 690 ns,
--X"A4" after 700 ns,
--X"15" after 710 ns,
--X"10" after 720 ns,
--X"00" after 730 ns,
--X"21" after 740 ns,
--X"DC" after 750 ns,
--X"8C" after 760 ns,
--X"97" after 770 ns,
--X"06" after 780 ns,
--X"5D" after 790 ns,
--X"04" after 800 ns,
--X"29" after 810 ns,
--X"4C" after 820 ns,
--X"01" after 830 ns,
--X"DD" after 840 ns,
--X"1D" after 850 ns,
--X"04" after 860 ns,
--X"AB" after 870 ns,
--X"15" after 880 ns,
--X"54" after 890 ns,
--X"01" after 900 ns,
--X"55" after 910 ns,
--X"60" after 920 ns,
--X"01" after 930 ns,
--X"CF" after 940 ns,
--X"1C" after 950 ns,
--X"34" after 960 ns,
--X"00" after 970 ns,
--X"00" after 980 ns,
--X"00" after 990 ns,
--X"00" after 1000 ns,
--X"00" after 1010 ns,
--X"80" after 1020 ns,
--X"08" after 1030 ns,
--X"9C" after 1040 ns,
--X"1C" after 1050 ns,
--X"10" after 1060 ns,
--X"00" after 1070 ns,
--X"01" after 1080 ns,
--X"08" after 1090 ns,
--X"50" after 1100 ns,
--X"15" after 1110 ns,
--X"10" after 1120 ns,
--X"00" after 1130 ns,
--X"21" after 1140 ns,
--X"E0" after 1150 ns,
--X"F2" after 1160 ns,
--X"FA" after 1170 ns,
--X"05" after 1180 ns,
--X"DD" after 1190 ns,
--X"1D" after 1200 ns,
--X"04" after 1210 ns,
--X"AB" after 1220 ns,
--X"15" after 1230 ns,
--X"54" after 1240 ns,
--X"01" after 1250 ns,
--X"55" after 1260 ns,
--X"60" after 1270 ns,
--X"01" after 1280 ns,
--X"CF" after 1290 ns,
--X"1C" after 1300 ns,
--X"34" after 1310 ns,
--X"00" after 1320 ns,
--X"00" after 1330 ns,
--X"00" after 1340 ns,
--X"00" after 1350 ns,
--X"00" after 1360 ns,
--X"80" after 1370 ns,
--X"08" after 1380 ns,
--X"9C" after 1390 ns,
--X"1C" after 1400 ns,
--X"10" after 1410 ns,
--X"00" after 1420 ns,
--X"01" after 1430 ns,
--X"08" after 1440 ns,
--X"50" after 1450 ns,
--X"15" after 1460 ns,
--X"10" after 1470 ns,
--X"00" after 1480 ns,
--X"21" after 1490 ns,
--X"E0" after 1500 ns,
--X"F2" after 1510 ns,
--X"FA" after 1520 ns,
--X"05" after 1530 ns,
--X"DD" after 1540 ns,
--X"1D" after 1550 ns,
--X"04" after 1560 ns,
--X"AB" after 1570 ns,
--X"15" after 1580 ns,
--X"54" after 1590 ns,
--X"01" after 1600 ns,
--X"E2" after 1610 ns,
--X"01" after 1620 ns,
--X"CF" after 1630 ns,
--X"1C" after 1640 ns,
--X"34" after 1650 ns,
--X"01" after 1660 ns,
--X"01" after 1670 ns,
--X"08" after 1680 ns,
--X"A4" after 1690 ns,
--X"15" after 1700 ns,
--X"10" after 1710 ns,
--X"00" after 1720 ns,
--X"21" after 1730 ns,
--X"01" after 1740 ns,
--X"01" after 1750 ns,
--X"01" after 1760 ns,
--X"01" after 1770 ns,
--X"E4" after 1780 ns,
--X"8A" after 1790 ns,
--X"97" after 1800 ns,
--X"06" after 1810 ns,
--X"01" after 1820 ns,
--X"5D" after 1830 ns,
--X"28" after 1840 ns,
--X"00" after 1850 ns,
--X"00" after 1860 ns,
--X"00" after 1870 ns
--;

--data_in <= X"00" after 0 ns,
--X"00" after 10 ns,
--X"00" after 20 ns,
--X"00" after 30 ns,
--X"00" after 40 ns,
--X"00" after 50 ns,
--X"08" after 60 ns,
--X"00" after 70 ns,
--X"12" after 80 ns,
--X"10" after 90 ns,
--X"00" after 100 ns,
--X"21" after 110 ns,
--X"E8" after 120 ns,
--X"EF" after 130 ns,
--X"AF" after 140 ns,
--X"D0" after 150 ns,
--X"01" after 160 ns,
--X"15" after 170 ns,
--X"38" after 180 ns,
--X"0F" after 190 ns,
--X"2C" after 200 ns,
--X"0F" after 210 ns,
--X"4C" after 220 ns,
--X"01" after 230 ns,
--X"0F" after 240 ns,
--X"20" after 250 ns,
--X"0F" after 260 ns,
--X"20" after 270 ns,
--X"0F" after 280 ns,
--X"20" after 290 ns,
--X"0F" after 300 ns,
--X"20" after 310 ns,
--X"0F" after 320 ns,
--X"20" after 330 ns,
--X"0F" after 340 ns,
--X"20" after 350 ns,
--X"0F" after 360 ns,
--X"20" after 370 ns,
--X"0F" after 380 ns,
--X"20" after 390 ns,
--X"A2" after 400 ns,
--X"8D" after 410 ns,
--X"14" after 420 ns,
--X"38" after 430 ns,
--X"A7" after 440 ns,
--X"12" after 450 ns,
--X"20" after 460 ns,
--X"47" after 470 ns,
--X"3C" after 480 ns,
--X"39" after 490 ns,
--X"34" after 500 ns,
--X"39" after 510 ns,
--X"64" after 520 ns,
--X"01" after 530 ns,
--X"00" after 540 ns,
--X"00" after 550 ns,
--X"00" after 560 ns,
--X"00" after 570 ns,
--X"00" after 580 ns,
--X"00" after 590 ns,
--X"80" after 600 ns,
--X"08" after 610 ns,
--X"70" after 620 ns,
--X"12" after 630 ns,
--X"10" after 640 ns,
--X"00" after 650 ns,
--X"01" after 660 ns,
--X"39" after 670 ns,
--X"28" after 680 ns,
--X"39" after 690 ns,
--X"24" after 700 ns,
--X"39" after 710 ns,
--X"24" after 720 ns,
--X"39" after 730 ns,
--X"24" after 740 ns,
--X"39" after 750 ns,
--X"24" after 760 ns,
--X"39" after 770 ns,
--X"24" after 780 ns,
--X"39" after 790 ns,
--X"24" after 800 ns,
--X"39" after 810 ns,
--X"24" after 820 ns,
--X"A6" after 830 ns,
--X"91" after 840 ns,
--X"14" after 850 ns,
--X"38" after 860 ns,
--X"D9" after 870 ns,
--X"12" after 880 ns,
--X"24" after 890 ns,
--X"A1" after 900 ns,
--X"13" after 910 ns,
--X"38" after 920 ns,
--X"E7" after 930 ns,
--X"12" after 940 ns,
--X"40" after 950 ns,
--X"05" after 960 ns,
--X"E5" after 970 ns,
--X"21" after 980 ns,
--X"24" after 990 ns,
--X"E9" after 1000 ns,
--X"12" after 1010 ns,
--X"4C" after 1020 ns,
--X"07" after 1030 ns,
--X"C2" after 1040 ns,
--X"02" after 1050 ns,
--X"D7" after 1060 ns,
--X"20" after 1070 ns,
--X"08" after 1080 ns,
--X"00" after 1090 ns,
--X"00" after 1100 ns,
--X"00" after 1110 ns,
--X"00" after 1120 ns,
--X"00" after 1130 ns,
--X"80" after 1140 ns,
--X"08" after 1150 ns,
--X"AC" after 1160 ns,
--X"20" after 1170 ns,
--X"10" after 1180 ns,
--X"00" after 1190 ns,
--X"01" after 1200 ns,
--X"08" after 1210 ns,
--X"20" after 1220 ns,
--X"13" after 1230 ns,
--X"10" after 1240 ns,
--X"00" after 1250 ns,
--X"21" after 1260 ns,
--X"F0" after 1270 ns,
--X"EE" after 1280 ns,
--X"96" after 1290 ns,
--X"06" after 1300 ns,
--X"1B" after 1310 ns,
--X"68" after 1320 ns,
--X"01" after 1330 ns,
--X"E7" after 1340 ns,
--X"12" after 1350 ns,
--X"50" after 1360 ns,
--X"01" after 1370 ns,
--X"E5" after 1380 ns,
--X"21" after 1390 ns,
--X"04" after 1400 ns,
--X"E9" after 1410 ns,
--X"12" after 1420 ns,
--X"40" after 1430 ns,
--X"02" after 1440 ns,
--X"E2" after 1450 ns,
--X"01" after 1460 ns,
--X"D7" after 1470 ns,
--X"20" after 1480 ns,
--X"04" after 1490 ns,
--X"00" after 1500 ns,
--X"00" after 1510 ns,
--X"00" after 1520 ns,
--X"00" after 1530 ns,
--X"00" after 1540 ns,
--X"80" after 1550 ns,
--X"08" after 1560 ns,
--X"20" after 1570 ns,
--X"13" after 1580 ns,
--X"10" after 1590 ns,
--X"00" after 1600 ns,
--X"21" after 1610 ns,
--X"D0" after 1620 ns,
--X"8C" after 1630 ns,
--X"97" after 1640 ns,
--X"06" after 1650 ns,
--X"1B" after 1660 ns,
--X"04" after 1670 ns,
--X"E7" after 1680 ns,
--X"12" after 1690 ns,
--X"20" after 1700 ns,
--X"E5" after 1710 ns,
--X"21" after 1720 ns,
--X"04" after 1730 ns,
--X"E9" after 1740 ns,
--X"12" after 1750 ns,
--X"40" after 1760 ns,
--X"02" after 1770 ns,
--X"93" after 1780 ns,
--X"13" after 1790 ns,
--X"60" after 1800 ns,
--X"01" after 1810 ns,
--X"D7" after 1820 ns
--;

--data_in <=
--X"00" after 0 ns,
--X"08" after 10 ns,
--X"f0" after 20 ns,
--X"12" after 30 ns,
--X"10" after 40 ns,
--X"00" after 50 ns,
--X"21" after 60 ns,
--X"e8" after 70 ns,
--X"b2" after 80 ns,
--X"b8" after 90 ns,
--X"99" after 100 ns,
--X"02" after 110 ns,
--X"8d" after 120 ns,
--X"13" after 130 ns,
--X"38" after 140 ns,
--X"07" after 150 ns,
--X"30" after 160 ns,
--X"07" after 170 ns,
--X"4c" after 180 ns,
--X"01" after 190 ns,
--X"07" after 200 ns,
--X"20" after 210 ns,
--X"07" after 220 ns,
--X"20" after 230 ns,
--X"07" after 240 ns,
--X"20" after 250 ns,
--X"07" after 260 ns,
--X"20" after 270 ns,
--X"07" after 280 ns,
--X"20" after 290 ns,
--X"07" after 300 ns,
--X"20" after 310 ns,
--X"07" after 320 ns,
--X"20" after 330 ns,
--X"07" after 340 ns,
--X"20" after 350 ns,
--X"07" after 360 ns,
--X"20" after 370 ns,
--X"07" after 380 ns,
--X"50" after 390 ns,
--X"02" after 400 ns,
--X"07" after 410 ns,
--X"4c" after 420 ns,
--X"01" after 430 ns,
--X"07" after 440 ns,
--X"24" after 450 ns,
--X"07" after 460 ns,
--X"20" after 470 ns,
--X"07" after 480 ns,
--X"20" after 490 ns,
--X"07" after 500 ns,
--X"24" after 510 ns,
--X"07" after 520 ns,
--X"1c" after 530 ns,
--X"07" after 540 ns,
--X"20" after 550 ns,
--X"07" after 560 ns,
--X"20" after 570 ns,
--X"07" after 580 ns,
--X"20" after 590 ns,
--X"07" after 600 ns,
--X"20" after 610 ns,
--X"07" after 620 ns,
--X"20" after 630 ns,
--X"07" after 640 ns,
--X"20" after 650 ns,
--X"07" after 660 ns,
--X"20" after 670 ns,
--X"07" after 680 ns,
--X"20" after 690 ns,
--X"07" after 700 ns,
--X"20" after 710 ns,
--X"07" after 720 ns,
--X"20" after 730 ns,
--X"07" after 740 ns,
--X"20" after 750 ns,
--X"07" after 760 ns,
--X"20" after 770 ns,
--X"07" after 780 ns,
--X"20" after 790 ns,
--X"07" after 800 ns,
--X"20" after 810 ns,
--X"07" after 820 ns,
--X"20" after 830 ns,
--X"07" after 840 ns,
--X"20" after 850 ns,
--X"07" after 860 ns,
--X"20" after 870 ns,
--X"07" after 880 ns,
--X"20" after 890 ns,
--X"07" after 900 ns,
--X"20" after 910 ns,
--X"07" after 920 ns,
--X"20" after 930 ns,
--X"07" after 940 ns,
--X"20" after 950 ns,
--X"07" after 960 ns,
--X"20" after 970 ns,
--X"00" after 980 ns,
--X"00" after 990 ns,
--X"00" after 1000 ns,
--X"00" after 1010 ns,
--X"00" after 1020 ns,
--X"80" after 1030 ns,
--X"07" after 1040 ns,
--X"20" after 1050 ns,
--X"08" after 1060 ns,
--X"0c" after 1070 ns,
--X"13" after 1080 ns,
--X"10" after 1090 ns,
--X"00" after 1100 ns,
--X"01" after 1110 ns,
--X"07" after 1120 ns,
--X"20" after 1130 ns,
--X"07" after 1140 ns,
--X"20" after 1150 ns,
--X"07" after 1160 ns,
--X"20" after 1170 ns,
--X"07" after 1180 ns,
--X"20" after 1190 ns,
--X"07" after 1200 ns,
--X"20" after 1210 ns,
--X"07" after 1220 ns,
--X"20" after 1230 ns,
--X"07" after 1240 ns,
--X"20" after 1250 ns,
--X"07" after 1260 ns,
--X"20" after 1270 ns,
--X"07" after 1280 ns,
--X"20" after 1290 ns,
--X"07" after 1300 ns,
--X"20" after 1310 ns,
--X"07" after 1320 ns,
--X"20" after 1330 ns,
--X"07" after 1340 ns,
--X"20" after 1350 ns,
--X"07" after 1360 ns,
--X"20" after 1370 ns,
--X"07" after 1380 ns,
--X"20" after 1390 ns,
--X"07" after 1400 ns,
--X"20" after 1410 ns,
--X"07" after 1420 ns,
--X"20" after 1430 ns,
--X"07" after 1440 ns,
--X"20" after 1450 ns,
--X"07" after 1460 ns,
--X"20" after 1470 ns,
--X"07" after 1480 ns,
--X"20" after 1490 ns,
--X"07" after 1500 ns,
--X"20" after 1510 ns,
--X"07" after 1520 ns,
--X"20" after 1530 ns,
--X"07" after 1540 ns,
--X"20" after 1550 ns,
--X"07" after 1560 ns,
--X"20" after 1570 ns,
--X"07" after 1580 ns,
--X"20" after 1590 ns,
--X"07" after 1600 ns,
--X"20" after 1610 ns,
--X"07" after 1620 ns
--;



-- trace of alea(2)
--enable <= '1' after 0 ns,
--'0' after 600 ns,
--'1' after 630 ns,
--'0' after 660 ns,
--'1' after 680 ns;
--data_in <=
--X"00" after 0 ns,
--X"08" after 10 ns,
--X"90" after 20 ns,
--X"13" after 30 ns,
--X"10" after 40 ns,
--X"00" after 50 ns,
--X"21" after 60 ns,
--X"FC" after 70 ns,
--X"bc" after 80 ns,
--X"b8" after 90 ns,
--X"99" after 100 ns,
--X"02" after 110 ns,
--X"91" after 120 ns,
--X"14" after 130 ns,
--X"38" after 140 ns,
--X"0C" after 150 ns,
--X"D7" after 160 ns,
--X"13" after 170 ns,
--X"40" after 180 ns,
--X"05" after 190 ns,
--X"81" after 200 ns,
--X"31" after 210 ns,
--X"24" after 220 ns,
--X"D9" after 230 ns,
--X"13" after 240 ns,
--X"4C" after 250 ns,
--X"08" after 260 ns,
--X"D6" after 270 ns,
--X"02" after 280 ns,
--X"F3" after 290 ns,
--X"2F" after 300 ns,
--X"08" after 310 ns,
--X"08" after 320 ns,
--X"00" after 330 ns,
--X"14" after 340 ns,
--X"10" after 350 ns,
--X"00" after 360 ns,
--X"21" after 370 ns,
--X"D8" after 380 ns,
--X"F3" after 390 ns,
--X"96" after 400 ns,
--X"06" after 410 ns,
--X"0B" after 420 ns,
--X"20" after 430 ns,
--X"D7" after 440 ns,
--X"13" after 450 ns,
--X"4C" after 460 ns,
--X"01" after 470 ns,
--X"81" after 480 ns,
--X"31" after 490 ns,
--X"04" after 500 ns,
--X"D9" after 510 ns,
--X"13" after 520 ns,
--X"50" after 530 ns,
--X"01" after 540 ns,
--X"E2" after 550 ns,
--X"01" after 560 ns,
--X"F3" after 570 ns,
--X"2F" after 580 ns,
--X"04" after 590 ns,
--X"01" after 600 ns,
--X"01" after 610 ns,
--X"01" after 620 ns,
--X"08" after 630 ns,
--X"00" after 640 ns,
--X"14" after 650 ns,
--X"01" after 660 ns,
--X"01" after 670 ns,
--X"10" after 680 ns,
--X"00" after 690 ns,
--X"21" after 700 ns,
--X"CC" after 710 ns,
--X"8B" after 720 ns,
--X"97" after 730 ns,
--X"06" after 740 ns,
--X"0B" after 750 ns,
--X"04" after 760 ns,
--X"CE" after 770 ns,
--X"01" after 780 ns,
--X"85" after 790 ns,
--X"15" after 800 ns,
--X"01" after 810 ns,
--X"00" after 820 ns,
--X"00" after 830 ns,
--X"00" after 840 ns,
--X"00" after 850 ns;


-- trace of for_loop(20)
--enable <= '1' after 0 ns;
--data_in <=
--X"08" after 0 ns,
--X"c8" after 10 ns,
--X"14" after 20 ns,
--X"10" after 30 ns,
--X"00" after 40 ns,
--X"21" after 50 ns,
--X"C0" after 60 ns,
--X"AD" after 70 ns,
--X"F9" after 80 ns,
--X"DE" after 90 ns,
--X"01" after 100 ns,
--X"79" after 110 ns,
--X"40" after 120 ns,
--X"06" after 130 ns,
--X"0C" after 140 ns,
--X"73" after 150 ns,
--X"3C" after 160 ns,
--X"73" after 170 ns,
--X"4C" after 180 ns,
--X"01" after 190 ns,
--X"73" after 200 ns,
--X"24" after 210 ns,
--X"73" after 220 ns,
--X"20" after 230 ns,
--X"73" after 240 ns,
--X"20" after 250 ns,
--X"73" after 260 ns,
--X"20" after 270 ns,
--X"73" after 280 ns,
--X"20" after 290 ns,
--X"73" after 300 ns,
--X"20" after 310 ns,
--X"73" after 320 ns,
--X"20" after 330 ns,
--X"73" after 340 ns,
--X"20" after 350 ns,
--X"73" after 360 ns,
--X"20" after 370 ns,
--X"73" after 380 ns,
--X"20" after 390 ns,
--X"73" after 400 ns,
--X"20" after 410 ns,
--X"73" after 420 ns,
--X"20" after 430 ns,
--X"73" after 440 ns,
--X"20" after 450 ns,
--X"73" after 460 ns,
--X"20" after 470 ns,
--X"73" after 480 ns,
--X"20" after 490 ns,
--X"73" after 500 ns,
--X"20" after 510 ns,
--X"73" after 520 ns,
--X"20" after 530 ns,
--X"73" after 540 ns,
--X"20" after 550 ns,
--X"A2" after 560 ns,
--X"DB" after 570 ns,
--X"17" after 580 ns,
--X"01" after 590 ns,
--X"00" after 600 ns,
--X"00" after 610 ns,
--X"00" after 620 ns,
--X"00" after 630 ns,
--X"00" after 640 ns;

--enable <= '1' after 0 ns, 
--          '0' after 960 ns,
--          '1' after 990 ns;
--reset <= '0' after 0 ns;
--data_in <= 
--X"00" after 0 ns,
--X"00" after 10 ns,
--X"00" after 20 ns,
--X"00" after 30 ns,
--X"00" after 40 ns,
--X"80" after 50 ns,
--X"08" after 60 ns,
--X"8c" after 70 ns,
--X"87" after 80 ns,
--X"00" after 90 ns,
--X"00" after 100 ns,
--X"21" after 110 ns,
--X"5b" after 120 ns,
--X"55" after 130 ns,
--X"55" after 140 ns,
--X"55" after 150 ns,
--X"55" after 160 ns,
--X"55" after 170 ns,
--X"86" after 180 ns,
--X"a5" after 190 ns,
--X"0d" after 200 ns,
--X"ED" after 210 ns,
--X"07" after 220 ns,
--X"8D" after 230 ns,
--X"08" after 240 ns,
--X"ff" after 250 ns,
--X"07" after 260 ns,
--X"7F" after 270 ns,
--X"7f" after 280 ns,
--X"7f" after 290 ns,
--X"7f" after 300 ns,
--X"86" after 310 ns,
--X"a9" after 320 ns,
--X"0D" after 330 ns,
--X"9f" after 340 ns,
--X"08" after 350 ns,
--X"67" after 360 ns,
--X"2d" after 370 ns,
--X"95" after 380 ns,
--X"06" after 390 ns,
--X"08" after 400 ns,
--X"5c" after 410 ns,
--X"88" after 420 ns,
--X"00" after 430 ns,
--X"00" after 440 ns,
--X"21" after 450 ns,
--X"59" after 460 ns,
--X"cd" after 470 ns,
--X"05" after 480 ns,
--X"08" after 490 ns,
--X"c0" after 500 ns,
--X"88" after 510 ns,
--X"00" after 520 ns,
--X"00" after 530 ns,
--X"21" after 540 ns,
--X"2d" after 550 ns,
--X"95" after 560 ns,
--X"06" after 570 ns,
--X"08" after 580 ns,
--X"5c" after 590 ns,
--X"88" after 600 ns,
--X"00" after 610 ns,
--X"00" after 620 ns,
--X"21" after 630 ns,
--X"86" after 640 ns,
--X"cd" after 650 ns,
--X"05" after 660 ns,
--X"08" after 670 ns,
--X"ac" after 680 ns,
--X"88" after 690 ns,
--X"00" after 700 ns,
--X"00" after 710 ns,
--X"21" after 720 ns,
--X"61" after 730 ns,
--X"21" after 740 ns,
--X"2d" after 750 ns,
--X"95" after 760 ns,
--X"06" after 770 ns,
--X"08" after 780 ns,
--X"5C" after 790 ns,
--X"88" after 800 ns,
--X"00" after 810 ns,
--X"00" after 820 ns,
--X"21" after 830 ns,
--X"86" after 840 ns,
--X"CD" after 850 ns,
--X"05" after 860 ns,
--X"08" after 870 ns,
--X"AC" after 880 ns,
--X"88" after 890 ns,
--X"00" after 900 ns,
--X"00" after 910 ns,
--X"21" after 920 ns,
--X"61" after 930 ns,
--X"86" after 940 ns,
--X"AD" after 950 ns,
--X"01" after 960 ns,
--X"01" after 970 ns,
--X"01" after 980 ns,
--X"0D" after 990 ns,
--X"01" after 1000 ns,
--X"00" after 1010 ns,
--X"00" after 1020 ns,
--X"00" after 1030 ns,
--X"00" after 1040 ns,
--X"00" after 1050 ns,
--X"00" after 1060 ns
--;


--enable <= '1' after 0 ns, 
--          '0' after 960 ns,
--          '1' after 990 ns;
--reset <= '1' after 0 ns, 
--         '0' after 100ns;
         
--data_in <= 
--X"08" after 100 ns,
--X"c8" after 104 ns,
--X"14" after 108 ns,
--X"10" after 112 ns,
--X"00" after 116 ns,
--X"21" after 120 ns,
--X"79" after 124 ns,
--X"73" after 128 ns,
--X"73" after 132 ns,
--X"73" after 136 ns,
--X"73" after 140 ns,
--X"73" after 144 ns,
--X"01" after 148 ns
--;

--enable <= '1' after 0 ns,
--          '0' after 2 ns,
--          '1' after 10 ns,
--          '0' after 26 ns,
--          '1' after 34 ns,
--          '1' after 42 ns, 
--          '0' after 54 ns, 
--          '1' after 58 ns        
--;--, 
----          '0' after 960 ns,
----          '1' after 990 ns;
--reset <= '0' after 8 ns, 
--         '0' after 16 ns;
         
--data_in <=
--X"01" after 2 ns,
--X"01" after 6 ns, 
--X"08" after 10 ns,
--X"c8" after 14 ns,
--X"14" after 18 ns,
----X"01" after 14 ns,
----X"01" after 18 ns,
--X"10" after 22 ns,
--X"01" after 26 ns, 
--X"01" after 30 ns,
--X"00" after 34 ns,
--X"21" after 38 ns,
--X"01" after 42 ns,
--X"01" after 46 ns,
--X"79" after 50 ns,
--X"73" after 54 ns,
--X"73" after 58 ns,
--X"01" after 62 ns,
--X"73" after 66 ns,
--X"73" after 70 ns,
--X"73" after 74 ns,
--X"01" after 78 ns
--;


-- testbench for post synthesis timing and functional simulation 
-- 100 ns should be added becuase it corresponds to GSR signal which is automatically done when the bitstream is downloaded and after that 100 ns are reserved for config
enable <= '1' after 100 ns,
          '0' after 116 ns,
          '1' after 124 ns, 
          '0' after 132 ns, 
          '1' after 140 ns, 
          '0' after 152 ns, 
          '1' after 156 ns 
                  
;--, 
--          '0' after 960 ns,
--          '1' after 990 ns;
reset <= '1' after 0 ns, 
         '0' after 100 ns;

data_in <= 
X"08" after 100 ns,
X"c8" after 104 ns,
X"14" after 108 ns,
--X"01" after 14 ns,
--X"01" after 18 ns,
X"10" after 112 ns,
X"01" after 116 ns, 
X"01" after 120 ns,
X"00" after 124 ns,
X"21" after 128 ns,
X"01" after 132 ns,
X"01" after 136 ns,
X"01" after 140 ns,
X"23" after 144 ns,
X"45" after 148 ns,
X"01" after 152 ns,
X"67" after 156 ns,
X"01" after 160 ns,
X"79" after 164 ns,
X"73" after 168 ns,
X"73" after 172 ns,
X"01" after 176 ns,
X"73" after 180 ns,
X"73" after 184 ns,
X"86" after 188 ns,
X"01" after 192 ns
;

         
--data_in <=
--X"01" after 102 ns,
--X"01" after 106 ns, 
--X"08" after 110 ns,
--X"c8" after 114 ns,
--X"14" after 118 ns,
----X"01" after 14 ns,
----X"01" after 18 ns,
--X"10" after 122 ns,
--X"01" after 126 ns, 
--X"01" after 130 ns,
--X"00" after 134 ns,
--X"21" after 138 ns,
--X"01" after 142 ns,
--X"01" after 146 ns,
--X"79" after 150 ns,
--X"73" after 154 ns,
--X"73" after 158 ns,
--X"01" after 162 ns,
--X"73" after 166 ns,
--X"73" after 170 ns,
--X"73" after 174 ns,
--X"01" after 178 ns
--;

wait;
end process;
end test1;
